Codeforces 782C Andryusha and Colored Balloons【思维+Dfs暴力染色】

来源:互联网 发布:韩国东大门代购淘宝店 编辑:程序博客网 时间:2024/06/05 17:39

C. Andryusha and Colored Balloons
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Andryusha goes through a park each day. The squares and paths between them look boring to Andryusha, so he decided to decorate them.

The park consists of n squares connected with(n - 1) bidirectional paths in such a way that any square is reachable from any other using these paths. Andryusha decided to hang a colored balloon at each of the squares. The baloons' colors are described by positive integers, starting from 1. In order to make the park varicolored, Andryusha wants to choose the colors in a special way. More precisely, he wants to use such colors that ifa, b andc are distinct squares that a and b have a direct path between them, andb and c have a direct path between them, then balloon colors on these three squares are distinct.

Andryusha wants to use as little different colors as possible. Help him to choose the colors!

Input

The first line contains single integer n (3 ≤ n ≤ 2·105) — the number of squares in the park.

Each of the next (n - 1) lines contains two integersx and y (1 ≤ x, y ≤ n) — the indices of two squares directly connected by a path.

It is guaranteed that any square is reachable from any other using the paths.

Output

In the first line print single integer k — the minimum number of colors Andryusha has to use.

In the second line print n integers, thei-th of them should be equal to the balloon color on thei-th square. Each of these numbers should be within range from1 to k.

Examples
Input
32 31 3
Output
31 3 2 
Input
52 35 34 31 3
Output
51 3 2 5 4 
Input
52 13 24 35 4
Output
31 2 3 1 2 
Note

In the first sample the park consists of three squares: 1 → 3 → 2. Thus, the balloon colors have to be distinct.

Illustration for the first sample.

In the second example there are following triples of consequently connected squares:

  • 1 → 3 → 2
  • 1 → 3 → 4
  • 1 → 3 → 5
  • 2 → 3 → 4
  • 2 → 3 → 5
  • 4 → 3 → 5
We can see that each pair of squares is encountered in some triple, so all colors have to be distinct.
Illustration for the second sample.

In the third example there are following triples:

  • 1 → 2 → 3
  • 2 → 3 → 4
  • 3 → 4 → 5
We can see that one or two colors is not enough, but there is an answer that uses three colors only.
Illustration for the third sample.

题目大意:

给你N个点,有N-1条边,构成一棵树,要求任意一条长度为2的链(包含三个点)中的三个点,颜色都不能相同。

问最少需要几种颜色就足够了,并且要求输出一种可行解。


思路:


显然,max(degree【i】)+1就是需要的最少颜色个数。

那么接下来我们只要随便Dfs染染色就行了。


#include<stdio.h>#include<string.h>#include<vector>using namespace std;vector<int >mp[300050];int color[300050];int degree[300050];int ans;void Dfs(int u,int from){    int tmp=1;    for(int i=0;i<mp[u].size();i++)    {        int v=mp[u][i];        if(v==from)continue;        else        {            for(int j=tmp;j<=ans;j++)            {                if(j!=color[u])                {                    if(from==-1)                    {                        color[v]=j;                        tmp=j+1;                        break;                    }                    else if(j!=color[from])                    {                        color[v]=j;                        tmp=j+1;                        break;                    }                }            }            Dfs(v,u);        }    }}int main(){    int n;    while(~scanf("%d",&n))    {        for(int i=1;i<=n;i++)mp[i].clear();        memset(degree,0,sizeof(degree));        for(int i=0;i<n-1;i++)        {            int x,y;            scanf("%d%d",&x,&y);            mp[x].push_back(y);            mp[y].push_back(x);            degree[x]++;            degree[y]++;        }        ans=0;        for(int i=1;i<=n;i++)ans=max(ans,degree[i]);        ans++;        printf("%d\n",ans);        color[1]=1;        Dfs(1,-1);        for(int i=1;i<=n;i++)        {            printf("%d ",color[i]);        }        printf("\n");    }}










0 0
原创粉丝点击